export interface QueryLeafNode {
    value: string;
}
export interface QueryAndNode {
    $and: QueryNode[];
}
export interface QueryOrNode {
    $or: QueryNode[];
}
export interface QueryNotNode {
    $not: QueryNode;
}
export declare function HasAttachment(): QueryLeafNode;
export declare function From(str: string): QueryLeafNode;
export declare function Subject(str: string): QueryLeafNode;
export declare function Label(str: string): QueryLeafNode;
export declare function AND(...nodes: QueryNode[]): QueryAndNode;
export declare function NOT(query: QueryNode): QueryNotNode;
export declare function OR(...nodes: QueryNode[]): QueryOrNode;
export declare type QueryNode = QueryLeafNode | QueryAndNode | QueryOrNode | QueryNotNode;
export declare function isAndNode(node: QueryNode): node is QueryAndNode;
export declare function isOrNode(node: QueryNode): node is QueryOrNode;
export declare function isNotNode(node: QueryNode): node is QueryNotNode;
export declare function isLeafNode(node: QueryNode): node is QueryLeafNode;
export declare function parse(query: string): QueryNode;
export declare function serialise(node: QueryNode): string;
